// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2018 Thomas Klose & Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;

namespace Hiperscan.ApoIdentCore.Reporting.Protocol
{
    [Flags]
    public enum PdfCreationStates
    {
        CreateTwoPages = 1,
        TryMode = 2,
        Init = 4,
        All = 7,
    }
    

    public class PdfCreationState
    {   
        public PdfCreationState()
        {
            this.Set(PdfCreationStates.Init, true);
            this.Set( PdfCreationStates.TryMode, true);
            this.Set(PdfCreationStates.CreateTwoPages, false);         
        }
        
        public void Set(PdfCreationStates state, bool on)
        {
            if (on == true)
                this.Current |= state;
            else
                this.Current &= ((int)PdfCreationStates.All - state);
        }

        public bool IsSet(PdfCreationStates state)
        {
            if ((this.Current & state) == state)
                return true;
            else
                return false;
        }


        public int CurrentPage = 1;
        public int TotalPages { get; set; } = 1;
        public PdfCreationStates Current { get; set; }
    }
}